﻿@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@model CyberaniumModels.RiskAssessment
<style>
    .arrowicon {
        position: absolute;
        bottom: -26px;
        left: 0px;
    }

    .boxcolor {
        float: left;
        position: relative;
        height: 25px;
        width: 309px;
        background: #00b050; /* Old browsers */
        background: -moz-linear-gradient(left, #00b050 0%, #ffdc00 50%, #ff0000 100%); /* FF3.6-15 */
        background: -webkit-linear-gradient(left, #00b050 0%,#ffdc00 50%,#ff0000 100%); /* Chrome10-25,Safari5.1-6 */
        background: linear-gradient(to right, #00b050 0%,#ffdc00 50%,#ff0000 100%); /* W3C, IE10+, FF16+, Chrome26+, Opera12+, Safari7+ */
    }

    .meter_view_base {
        width: 250px;
        overflow: hidden;
        height: 150px;
        display: block;
        position: relative
    }

    .meter_view {
        position: absolute;
        top: 25px;
        width: 250px;
        height: 250px;
        border-radius: 100%;
        background: #ccc;
        border: solid 20px #444;
    }

    .meter_point {
        width: 106px;
        height: 8px;
        /*background: #444;*/
        position: absolute;
        bottom: 105px
    }

        .meter_point:before {
            content: "";
            height: 8px;
            width: 20px;
            background: #444;
            position: absolute;
            top: 0;
            left: 0px;
        }

        .meter_point.p1 {
            transform-origin: 100% 4px;
            transform: rotate( 30deg);
        }

        .meter_point.p2 {
            transform-origin: 100% 4px;
            transform: rotate( 60deg);
        }

        .meter_point.p3 {
            transform-origin: 100% 4px;
            transform: rotate( 90deg);
        }

        .meter_point.p4 {
            transform-origin: 100% 4px;
            transform: rotate( 120deg);
        }

        .meter_point.p5 {
            transform-origin: 100% 4px;
            transform: rotate( 150deg);
        }

    .niddle {
        width: 85px;
        left: 23px;
        height: 8px;
        background: #444;
        position: absolute;
        bottom: 105px;
        border-bottom-left-radius: 100% !important;
        border-bottom-right-radius: 5px !important;
        border-top-left-radius: 100% !important;
        border-top-right-radius: 5px !important;
        transform-origin: 100% 4px;
    }

    .box_head {
        background: #0091da;
        font-size: 14px;
        padding: 10px;
        color: #fff;
        text-align: center;
    }

    .box_in {
        display: flex;
        padding: 10px;
    }

    .overallScore {
        width: 100%;
    }

    .largeText {
        width: 100%;
        text-align: center;
        font-size: 48px;
        padding: 21px 0px
    }

    .smText {
        text-align: center;
        width: 100%;
        font-size: 14px;
    }

</style>
<section>
    <div class="right_section">
        @Html.HiddenFor(x => x.OrgId)
        @Html.HiddenFor(x => x.CategoryId)
        @Html.HiddenFor(x => x.QuestionnaireID)
        <div class="pb-2 mt-3 mb-2 border-bottom box_title pl-4">
            Risk Assessment Report for @Model.CategoryName
            <a data-ajax="true" class="backtolist" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="AssessmentReport" asp-controller="RiskAssessment" asp-area="ApplicationManagement" asp-route-orgId="@Model.OrgId" asp-route-CategoryId="@Model.CategoryId" asp-route-QuestionnaireID="@Model.QuestionnaireID" asp-route-EnablerName="@Model.CategoryName">Back to Menu</a>
        </div>
        <div class="col-lg-12 col-md-8 col-sm-8 col-xs-8">
            <div class="right_panel">
                <div class="right_content">
                    <div class="row">
                        <div class="col-4">
                            <table class="table table-bordered text-center mb-1">
                                <thead class="bg-warning text-white"><tr><td>Domain</td><td>Base Risk Score</td></tr></thead>
                                <tbody>
                                    @foreach (var item in Model.RiskDomainList)
                                    {
                                        <tr><td class="domains" value="@item.Value">@item.Name</td><td id="domain@(item.Value)">0</td></tr>
                                    }
                                </tbody>
                            </table>
                        </div>
                        <div class="col-4">
                            <div class="box">
                                <div class="box_head">
                                    Overall Base Risk Score of the @Model.CategoryName
                                </div>
                                <div class="box_in" style="border:solid 1px #444;margin-top:10px;">
                                    <div class="overallScore">
                                        <div class="largeText" id="divAverage">0/5</div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="col-4">
                            <div class="box">
                                <div class="box_head">Risk – O - Meter</div>
                                <div class="col-6 p-3">
                                    <label id="impactScore">Impact Score : 0</label>
                                    <div class="boxcolor">
                                        <div class="arrowicon">
                                            <i class="fa fa-caret-up fa-3x" aria-hidden="true"></i>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="row mb-1 text-right">
                        <div class="col-2 offset-10">
                            <button class="btn btn-info" onclick="SubmitDomainBaseRiskScore()">Save score</button>
                        </div>
                    </div>
                        <div class="panel-group" id="accordion" role="tablist" aria-multiselectable="false">
                            @foreach (var item in Model.ThreatList)
                            {
                                <div class="panel panel-default">
                                    <input type="hidden" value="@item.ThreatId" class="inputThreats" />
                                    @foreach (var ele in Model.DomainThreatMapList.Where(x => x.ThreatId == item.ThreatId))
                                    {
                                        <input type="hidden" class="domain@(ele.DomainId)" id="@(ele.DomainId+"_"+item.ThreatId)" value="@(ele.Status?1:0)" />
                                    }
                                    <div class="panel-heading" role="tab" id="heading@(item.ThreatId)">
                                        <h4 class="panel-title">
                                            <a class="collapsed" role="button" data-toggle="collapse" data-parent="#accordion" href="#collapse@(item.ThreatId)" aria-expanded="false" aria-controls="collapse@(item.ThreatId)">
                                                @(item.ThreatCode +" - "+ item.ThreatName)
                                            </a>
                                        </h4>
                                    </div>
                                    <style>
                                        .txtCenter th {
                                            text-align: center
                                        }

                                        .txtCenter td {
                                            text-align: center
                                        }
                                    </style>
                                    <div id="collapse@(item.ThreatId)" class="panel-collapse collapse" role="tabpanel" aria-labelledby="heading@(item.ThreatId)">
                                        <div class="panel-body">
                                            <div class="row">
                                                <div class="col-12">
                                                    <div class="table_control">
                                                        <table class="table">
                                                            <thead class="txtCenter">
                                                                <tr>
                                                                    <th>Probability</th>
                                                                    <th>Impact</th>
                                                                    <th>Average P</th>
                                                                    <th>Average D,C</th>
                                                                    <th>Revised Probability Score</th>
                                                                    <th>Revised Impact</th>
                                                                    <th>Threat Residual Risk</th>
                                                                </tr>
                                                            </thead>
                                                            <tbody>
                                                                <tr class="txtCenter">
                                                                    <td id="Probability@(item.ThreatId)">@(item.Score)</td>
                                                                    <td id="Impact@(item.ThreatId)">1</td>
                                                                    <td id="AvgP@(item.ThreatId)">@(item.Score)</td>
                                                                    <td id="AvgDC@(item.ThreatId)">N/A</td>
                                                                    <td id="RPS@(item.ThreatId)">@(item.Score)</td>
                                                                    <td id="RI@(item.ThreatId)">1</td>
                                                                    <td class="tdThreat" value="@item.ThreatId" id="TRR@(item.ThreatId)">@(item.Score*1)</td>
                                                                </tr>
                                                                <tr>
                                                                    <td colspan="7">
                                                                        <table class="table m-0">
                                                                            <thead class="txtCenter">
                                                                                <tr>
                                                                                    <th>SNo</th>
                                                                                    <th>Control Id</th>
                                                                                    <th>Control Name</th>
                                                                                    <th style="width:500px">Control Description</th>
                                                                                    <th>Control Type</th>
                                                                                    <th>Control Rating</th>
                                                                                    <th style="width:400px">GAPs Identified</th>
                                                                                </tr>
                                                                            </thead>
                                                                            <tbody id="ThreatDomain@(item.ThreatId)"></tbody>
                                                                        </table>
                                                                    </td>
                                                                </tr>
                                                            </tbody>
                                                        </table>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            }
                        </div>
                    </div>
                </div>
        </div>
    </div>
</section>
<script>
    $(() => {
        $('.inputThreats').each((i, ele) => {
            var threatId = Number($(ele).val());
            var orgId = Number($('#OrgId').val());
            var conCatId = Number($('#CategoryId').val());
            var questionnaireId = Number($('#QuestionnaireID').val());
            $('#preloader').show();
            var html = '';
            $.ajax({
                url: '/ApplicationManagement/RiskAssessment/GetControlListByIds',
                async: false,
                data: { orgId: orgId, conCatId: conCatId, questionnaireId: questionnaireId },
                success: (res) => {
                    if (res.length > 0) {
                        $.each(res, function (di, dvalue) {
                            var ControlType = dvalue.controlTypeID == 1 ? 'D' : dvalue.controlTypeID == 2 ? 'C' : 'P';
                            html += '<tr>' +
                                '<td class="text-center">' + ++di + '</td>' +
                                '<td>' + dvalue.controlId + '</td>' +
                                '<td>' + dvalue.controlName + '</td>' +
                                '<td>' + dvalue.controlDescription + '</td>' +
                                '<td class="text-center" name="td' + threatId + '" style="font-weight:bolder">' + ControlType + '</td>' +
                                '<td class="rating_' + threatId + '">' + dvalue.rating + '</td>' +
                                '<td></td>' +
                                '</tr>';
                        })
                    }
                }
            })
            $('#ThreatDomain' + threatId).append(html);
            $('#preloader').hide();
            calculateAverage(threatId)
        })
        calculateBaseRiskScore()
    })
    function calculateAverage(threatId) {
        var cTotal = 0, cLength = 0, pTotal = 0, pLength = 0;
        $('.rating_' + threatId).each(function (i, ele) {
            var val = parseInt($(ele).text());
            var text = $('[name="td' + threatId + '"]').eq(i).text();
            if (val == 0) return;
            if (text == 'P') pLength++; else cLength++;
            if (text == 'P') pTotal += parseInt(val); else cTotal += parseInt(val);
        })
        var p = parseInt($('#Probability' + threatId).text());
        var i = parseInt($('#Impact' + threatId).text());
        $('#Impact' + threatId).text('1');
        var ap = 0, rp = 0;
        if (pTotal > 0 && pLength > 0) {
            $('#AvgP' + threatId).text((pTotal / pLength).toFixed(2));
            ap = parseFloat($('#AvgP' + threatId).text());
            rp = ap <= 1 ? p * 1 : ap <= 2 ? p * 0.8 : ap <= 3 ? p * 0.5 : ap <= 4 ? p * 0.3 : p * 0.1;
            $('#RPS' + threatId).text(rp.toFixed(2));
        }
        var ac = 0, ri = 0;
        if (cTotal > 0 && cLength > 0) {
            $('#AvgDC' + threatId).text((cTotal / cLength).toFixed(2));
            ac = parseFloat($('#AvgDC' + threatId).text());
            ri = ac <= 1 ? i * 1 : ac <= 2 ? i * 0.8 : ac <= 3 ? i * 0.5 : ac <= 4 ? i * 0.3 : i * 0.1;
            $('#RI' + threatId).text(ri.toFixed(2));
        }
        debugger;
        var trr = Number(1 + (Number(rp > 0 ? rp : p * ri > 0 ? ri : i) - 0.01) * Number((5 - 1) / (5 - 0.01)));
        $('#TRR' + threatId).text(trr.toFixed(2));
    }
    function calculateBaseRiskScore() {
        var totalLength = 0, totalScore = 0;
        $('.domains').each((i, ele) => {
            var domainId = parseInt($(ele).attr('value')), length = 0, value = 0;
            $('.tdThreat').each((i, td) => {
                var score = parseFloat($(td).text()).toFixed(2);
                var threatId = parseInt($(td).attr('value'));
                var val = parseInt($('#' + domainId + '_' + threatId).val());
                if (val > 0) {
                    value += parseFloat(score);
                    length++;
                }
            })
            var avg = (value / length).toFixed(2);
            $('#domain' + domainId).text(isNaN(avg) ? 0 : avg);
            totalScore += parseFloat(isNaN(avg) ? 0 : avg);
            totalLength++;
        })

        $('#impactScore').text('Impact Score : ' + (totalScore / totalLength).toFixed(2));
        $('.arrowicon').css('left', ((totalScore / totalLength).toFixed(2) * ((totalScore / totalLength).toFixed(2) > 1 ? 69 : 1)) + 'px');

        $('#divAverage').text((totalScore / totalLength).toFixed(2) + "/5");
        $('#meter').css('transform', 'rotate(' + (parseFloat($('#divAverage').text()) * 30) + 'deg)');
    }
    function SubmitDomainBaseRiskScore() {
        var array = [];
        $('.domains').each((i, ele) => {
            var domainId = parseInt($(ele).attr('value'));
            var score = $('#domain' + domainId).text();
            array[i] = {
                RiskDomainId: domainId,
                Score: score
            }
        })
        var model = {
            OrgId: $('#OrgId').val(),
            ConCatId: $('#CategoryId').val(),
            QuestionnaireId: $('#QuestionnaireID').val(),
            DomainBaseRiskScoreXML: JSON.stringify(array)
        }
        $.post('/ApplicationManagement/RiskAssessment/SubmitDomainBaseRiskScore', { model: model }, (res) => {
            if (res.isSuccess) toastr.success('Saved successfully.');
            else toastr.error('Something went worng!');
        })
    }
</script>